import { CodeWithSourceMap, SourceNode } from 'source-map';
import { Binding, Document as DOMDocument, TypeNode, BindingContext } from '../parser/syntax-tree';
export declare class SourceBuilder {
    markupFileName: string;
    private document;
    private revision;
    private currentNode;
    private rootNode;
    constructor(markupFileName: string, document: DOMDocument);
    /**
     * Create a new revision of the content.
     * @returns the new revision number
     */
    commit(name?: string): void;
    changes(): SourceNode;
    /**
     * Load scaffold into a source file
     */
    private createScaffold;
    private mapIdentifier;
    private mapExpression;
    private join;
    private createImportStatements;
    createBindinghandlerImports(bindingNames: string[]): void;
    createRootBindingContexts(context: BindingContext): void;
    getContent(): CodeWithSourceMap;
    createContextTransformation(bindingContextId: string, binding: Binding, contextMembers: string[], dataMembers: string[]): void;
    emitContextDefinition(ancestorContextId: string, binding: Binding): void;
    emitContextDefinition2(typeNode: TypeNode): void;
}
//# sourceMappingURL=source-builder.d.ts.map