import * as ts from 'typescript';
import { Location } from './parser/location';
export declare enum Severity {
    Off = 1,
    Warning = 2,
    Error = 3
}
export declare class Diagnostic {
    filePath: string;
    location?: Location | undefined;
    code: string;
    message: string;
    name: string;
    severity: Severity;
    constructor(filePath: string, diagnostic: DiagnosticDescription | ts.Diagnostic | keyof typeof diagnostics, location?: Location | undefined, ...args: string[]);
}
export declare function setProblemsSeverity(problems: Diagnostic[], diagnosticSeverity: {
    [key in string]?: Severity;
}): Diagnostic[];
export interface DiagnosticDescription {
    code: string;
    message: string;
}
interface DiagnosticSpecification {
    code: string;
    message: string;
    arguments?: readonly string[];
}
export declare const diagnostics: Record<"multiple-context-bindings" | "no-viewmodel-reference" | "multiple-comment-bindings" | "javascript-syntax-error" | "could-not-find-viewmodel" | "missing-end-of-virtual-element" | "missing-start-of-virtual-element" | "virtual-element-start-and-end-not-on-same-depth" | "virtual-element-prefix-required" | "unbalanced-start-end-tags" | "can-not-find-knockout" | "binding-context-unknown" | "binding-context-any" | "parser-error" | "multiple-context-generating-bindings" | "binding-unknown", DiagnosticSpecification>;
export {};
//# sourceMappingURL=diagnostic.d.ts.map