"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBindingHandlerContextType = exports.wrapBindingHandlerContextTypes = void 0;
function hasAdditionalTypes(bhct) {
    return Boolean(bhct === null || bhct === void 0 ? void 0 : bhct.additionalTypes);
}
function wrapBindingHandlerContextTypes(bindingHandlers, handlersExtenderName) {
    return `\n${bindingHandlers.filter(hasAdditionalTypes).join('\n')}\n\ninterface Handlers extends ${handlersExtenderName} {\n${bindingHandlers.map(bh => bh.contextProperty).join('\n\t')}\n}`;
}
exports.wrapBindingHandlerContextTypes = wrapBindingHandlerContextTypes;
function getBindingHandlerContextType(bindingHandler) {
    if (typeof bindingHandler.valueType === 'string') {
        return {
            contextProperty: `${bindingHandler.name}: BindingHandler<${bindingHandler.valueType}>`
        };
    }
    else {
        return {
            contextProperty: `${bindingHandler.name}: ${bindingHandler.valueType.customType}`,
            additionalTypes: bindingHandler.valueType.additionalTypes
        };
    }
}
exports.getBindingHandlerContextType = getBindingHandlerContextType;
//# sourceMappingURL=binding-handlers.js.map