import { Document, Node } from './parser/syntax-tree';
import { Diagnostic } from './diagnostic';
import { SourceMapGenerator } from 'source-map';
export interface Reporting {
    registerOutput(filename: string, code: string, map: SourceMapGenerator): void;
    addDiagnostic(...diags: Diagnostic[]): void;
    disableAllDiagnostics(): void;
    disableDiagnostics(keys: string[]): void;
    enableAllDiagnostics(): void;
    enableDiagnostics(keys: string[]): void;
}
export declare function createProgram(): Program;
export declare class Program implements Reporting {
    private diagnostics;
    private diagnosticsDisabled;
    private disabledDiagnostics;
    private enabledDiagnostics;
    private diagIsRule;
    addDiagnostic(...diags: Diagnostic[]): void;
    registerOutput(filename: string, code: string, map: SourceMapGenerator): void;
    disableAllDiagnostics(): void;
    disableDiagnostics(keys: string[]): void;
    enableAllDiagnostics(): void;
    enableDiagnostics(keys: string[]): void;
    parseNodes(filePath: string, document: string, bindingNames?: string[] | undefined, forceToXML?: boolean): Node[];
    /**
     * Creates a pre-compiled view from the input view. Used for type checking.
     * @param document the tree of bindings for the view
     * @returns the file path to the generated compiled view
     */
    compile(documents: Document[]): Promise<Diagnostic[]>;
}
//# sourceMappingURL=program.d.ts.map