export declare namespace utils {
    /**
     * Utility function to make sure that a uniform representation is used when e.g. comparing paths.
     * The same path represented in both posix and win32 format should result in the same string.
     * @param platformDependentPath path specified as win32 or posix path
     * @returns posix representation of the path.
     */
    function canonicalPath(platformDependentPath: string): string;
    function isReserved(keyword: string): boolean;
    type FlatArray<Arr, Depth extends number> = {
        'done': Arr;
        'recur': Arr extends ReadonlyArray<infer InnerArr> ? FlatArray<InnerArr, [-1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20][Depth]> : Arr;
    }[Depth extends -1 ? 'done' : 'recur'];
    function flat<A extends any[][], D extends number = 1>(array: A, _depth?: D): FlatArray<A, D>[];
}
export default utils;
//# sourceMappingURL=utils.d.ts.map