"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.utils = void 0;
const path = __importStar(require("path"));
// eslint-disable-next-line @typescript-eslint/no-namespace
var utils;
(function (utils) {
    /**
     * Utility function to make sure that a uniform representation is used when e.g. comparing paths.
     * The same path represented in both posix and win32 format should result in the same string.
     * @param platformDependentPath path specified as win32 or posix path
     * @returns posix representation of the path.
     */
    function canonicalPath(platformDependentPath) {
        return platformDependentPath.split(path.sep).join(path.posix.sep);
    }
    utils.canonicalPath = canonicalPath;
    function isReserved(keyword) {
        return ['break', 'case', 'catch', 'class', 'const', 'continue', 'debugger', 'default', 'delete', 'do', 'else', 'enum', 'export', 'extends', 'false', 'finally', 'for', 'function', 'if', 'import',
            'in', 'instanceof', 'new', 'null', 'return', 'super', 'switch', 'this', 'throw', 'true', 'try', 'typeof', 'var', 'void', 'while', 'with', 'as', 'implements', 'interface', 'let', 'package',
            'private', 'protected', 'public', 'static', 'yield', 'any', 'boolean', 'constructor', 'declare', 'get', 'module', 'require', 'number', 'set', 'string', 'symbol', 'type', 'from', 'of',
            'namespace', 'maybe', 'async', 'await'].includes(keyword);
    }
    utils.isReserved = isReserved;
    /* eslint-disable */
    function flat(array, _depth) {
        const depth = isNaN(_depth) ? 1 : Number(_depth);
        if (depth) {
            return (Array.prototype.reduce.call(array, ((acc, cur) => {
                if (Array.isArray(cur)) {
                    acc.push.apply(acc, flat(cur, depth - 1));
                }
                else {
                    acc.push(cur);
                }
                return acc;
            }), []));
        }
        else {
            return Array.prototype.slice.call(array);
        }
    }
    utils.flat = flat;
    /* eslint-enable */
})(utils = exports.utils || (exports.utils = {}));
exports.default = utils;
//# sourceMappingURL=utils.js.map